import { AbstractTable } from "drizzle-orm";

export default class UsersTable extends AbstractTable<UsersTable> {
  public id = this.int('id').autoIncrement().primaryKey();
  public fullName = this.varchar('full_name_to_alter', { size: 256 });

  public test = this.decimal('column_to_delete1', { notNull: true, precision: 100, scale: 2 });
  public test1 = this.bigint('column_to_todelet2', { notNull: true });

  public fullNameIndex = this.index(this.fullName);

  public tableName(): string {
    return 'users';
  }
}
