import { AbstractTable } from 'drizzle-orm';
import { rolesEnum, roles2Enum} from '../types/types'
import UsersTable from './usersTable';

export default class AuthOtpTable extends AbstractTable<AuthOtpTable> {
  public id = this.int('id').autoIncrement().primaryKey();
  public phone = this.varchar('phone', { size: 256 });

  public column1 = this.varchar('to_add_default', { size: 256 }).defaultValue('added_default');
  public column2 = this.varchar('to_add_notnull', { size: 256, notNull: true});
  public column3 = this.varchar('to_change_default', { size: 256 }).defaultValue('defaultToChange');
  public column4 = this.varchar('to_drop_default', { size: 256 });
  public column5 = this.varchar('to_drop_notnull', { size: 256 });

  public roleEnum1 = this.type(rolesEnum, 'role')
  public roleEnum2 = this.type(roles2Enum, 'role2')
  public userId = this.int('user_id').foreignKey(UsersTable, (table) => table.id);

  public tableName(): string {
    return 'auth_otp_renamed';
  }
}
