import { AbstractTable } from "drizzle-orm";

export default class UsersTable extends AbstractTable<UsersTable> {
  public id = this.int('id').autoIncrement().primaryKey();
  public phone = this.varchar('phone', { size: 256 }).unique();
  public fullName = this.varchar('full_name_to_alter', { size: 512 });

  public createdAt = this.timestamp('created_at', { notNull: true });
  public updatedAt = this.timestamp('updated_at', { notNull: true });

  public phoneFullNameIndex = this.index([this.phone, this.fullName]);
  
  // deleted
  // public fullNameIndex = this.index(this.fullName);

  public tableName(): string {
    return 'users2';
  }
}
