import { AbstractTable } from 'drizzle-orm';
import UsersTable from './usersTable';
import { rolesEnum } from '../types/types';

export default class AuthOtpTable extends AbstractTable<AuthOtpTable> {
  public id = this.int('id').autoIncrement().primaryKey();
  public phone = this.varchar('phone', { size: 256 });
  public otp = this.varchar('otp', { size: 256 });
  public issuedAt = this.timestamp('issued_at', { notNull: true });
  public createdAt = this.timestamp('created_at', { notNull: true });
  public updatedAt = this.timestamp('updated_at', { notNull: true });

  public roleEnum = this.type(rolesEnum, 'role')
  public userId = this.int('user_id').foreignKey(UsersTable, (table) => table.id);

  public test = this.jsonb<string[]>('test');

  public tableName(): string {
    return 'auth_otp';
  }
}
