import fs from 'fs'
import serialize from './src/serilizer'

// TODO: export as a function w

const dry = {
    version: "1",
    tables: {},
    enums: {}
}

const prepareMigration = (path: string = 'drizzle'): {} => {
    const root = path
    const files = fs.readdirSync('./')
    const drizzleFolder = files.find((it) => {
        return it === root
    })

    if (!drizzleFolder) {
        fs.mkdirSync(root)
    }

    const migrationFolders = fs.readdirSync(`./${root}`)

    let prevSnapshot;

    if (migrationFolders.length === 0) {
        prevSnapshot = dry
    } else {
        migrationFolders.sort()
        const lastSnapshotFolder = migrationFolders[migrationFolders.length - 1]
        prevSnapshot = fs.readFileSync(`./${root}/${lastSnapshotFolder}/snapshot.json`).toJSON()
    }

    const timestamp = Date.now()
    const migrationFolder = `./${root}/${timestamp}`
    fs.mkdirSync(migrationFolder)

    const version = 'v3'
    const dir = `./data/${version}`
    const tbls = `${dir}/tables/`
    const tps = `${dir}/types/`

    const result = serialize(tbls, tps)
    fs.writeFileSync(`${migrationFolder}/snapshot.json`, JSON.stringify(result, null, 2))

    return { prev: prevSnapshot, cur: result }
}

export default prepareMigration;