import { Named, RenamedObject } from 'cli/commands/migration/migrate';

interface ScalarDict {
  [key: string]: string
}

export default (
  data: {
    title: string;
    values: Named[] | RenamedObject<Named>[]
  }[],
): ScalarDict[] => {
  const array: ScalarDict[] = [];

  array.length = data.reduce((acc: number, { values }) => {
    if (acc < values.length) {
      return values.length;
    }
    return acc;
  },
  0);

  array.fill({ '': '' });

  return array.map((_, i) => {
    const temp = {} as ScalarDict;

    data.forEach((item: any, ind: number) => {
      temp[data[ind].title] = item.values[i]?.old?.name
        ? `${item.values[i]?.old?.name} -> ${item.values[i]?.new?.name}`
        : item.values[i]?.name || '';
    });

    return temp as ScalarDict;
  });
};
